#ifndef F_CPU
#define F_CPU 4000000UL
#endif

#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include "morse.h"

// const uint8_t prmMorseArray PROGMEM;

void morse_char( uint8_t ascii_char )
{
	if( ascii_char == 32 ) // space
	{
		_delay_ms(WORD_LENGTH);
	}
	else
	{
		uint8_t array[127];
		array[48] = 0b00111111;		// 0
		array[49] = 0b00111110;
		array[50] = 0b00111100;
		array[51] = 0b00111000;
		array[52] = 0b00110000;
		array[53] = 0b00100000;
		array[54] = 0b00100001;
		array[55] = 0b00100011;
		array[56] = 0b00100111;
		array[57] = 0b00101111;		// 9
		
		array[97] = 0b00000110;		// a
		array[98] = 0b00010001;
		array[99] = 0b00010101;
		array[100] = 0b00001001;
		array[101] = 0b00000010;
		array[102] = 0b00010100;
		array[103] = 0b00001011;
		array[104] = 0b00010000;
		array[105] = 0b00000100;
		array[106] = 0b00011110;
		array[107] = 0b00001101;
		array[108] = 0b00010010;
		array[109] = 0b00000111;
		array[110] = 0b00000101;
		array[111] = 0b00001111;
		array[112] = 0b00010110;
		array[113] = 0b00011011;
		array[114] = 0b00001010;
		array[115] = 0b00001000;
		array[116] = 0b00000011;
		array[117] = 0b00001100;
		array[118] = 0b00011000;
		array[119] = 0b00001110;
		array[120] = 0b00011001;
		array[121] = 0b00011101;
		array[122] = 0b00010011;	// z
		
		uint8_t work_byte;
		uint8_t morse_byte = pgmMorseArray[ascii_char];
		
		do
		{
			work_byte = 0b00000001 & morse_byte;	// get the LSB
			PORTB |= (1<<PB0);
			SOUND_ON();
			
			if( work_byte == 1 )	// if LSB is 1 it's a DAH
				_delay_ms(DAH_LENGTH);
			else if( work_byte == 0 )	// else it's a DIT
				_delay_ms(DIT_LENGTH);
				
			PORTB &= !(1<<PB0);
			SOUND_OFF();
			_delay_ms(DIT_LENGTH);	// pause between symbols
			morse_byte = morse_byte>>1;		// shift the morse_byte one position to the right
		}
		while( morse_byte != 1 );	// if the Value ofthe remaining byte is 1, the character is done
	}
}

void morse_string( const char* string )
{
	while( *string ) {
		morse_char( *string );
		string++;
		_delay_ms(DAH_LENGTH);	// pause of dah between two characters of one word
	}
}
